#### POSIX Threads for Windows – REFERENCE - Pthreads-w32

Reference Index

Table of Contents

## Name

pthread_mutexattr_getpshared, pthread_mutexattr_setpshared - get and set the process-shared attribute

## Synopsis

#include <pthread.h>

int pthread_mutexattr_getpshared(const pthread_mutexattr_t * restrict attr, int *restrict pshared);
int pthread_mutexattr_setpshared(pthread_mutexattr_t *attr, int pshared);

## Description

The pthread_mutexattr_getpshared function shall obtain the value of the process-shared attribute from the attributes object referenced by attr. The pthread_mutexattr_setpshared function shall set the process-shared attribute in an initialized attributes object referenced by attr.

The process-shared attribute is set to PTHREAD_PROCESS_SHARED to permit a mutex to be operated upon by any thread that has access to the memory where the mutex is allocated, even if the mutex is allocated in memory that is shared by multiple processes. If the process-shared attribute is PTHREAD_PROCESS_PRIVATE, the mutex shall only be operated upon by threads created within the same process as the thread that initialized the mutex; if threads of differing processes attempt to operate on such a mutex, the behavior is undefined. The default value of the attribute shall be PTHREAD_PROCESS_PRIVATE.

Pthreads-w32 defines _POSIX_THREAD_PROCESS_SHARED in pthread.h as -1 to indicate that these routines are implemented but the process shared option is not supported.

## Return Value

Upon successful completion, pthread_mutexattr_setpshared shall return zero; otherwise, an error number shall be returned to indicate the error.

Upon successful completion, pthread_mutexattr_getpshared shall return zero and store the value of the process-shared attribute of attr into the object referenced by the pshared parameter. Otherwise, an error number shall be returned to indicate the error.

## Errors

The pthread_mutexattr_getpshared and pthread_mutexattr_setpshared functions may fail if:

EINVAL
  The value specified by attr is invalid.

The pthread_mutexattr_setpshared function may fail if:

EINVAL
  The new value specified for the attribute is outside the range of legal values for that attribute.
ENOTSUP
  The new value specified for the attribute is PTHREAD_PROCESS_SHARED.

These functions shall not return an error code of [EINTR].

The following sections are informative.

## Examples

None.

## Application Usage

None.

## Rationale

None.

## Future Directions

None.

## See Also

pthread_cond_destroy(3) , pthread_create(3) , pthread_mutex_destroy(3) , pthread_mutexattr_destroy(3) , the Base Definitions volume of IEEE Std 1003.1-2001, <pthread.h>

## Copyright

Portions of this text are reprinted and reproduced in electronic form from IEEE Std 1003.1, 2003 Edition, Standard for Information Technology -- Portable Operating System Interface (POSIX), The Open Group Base Specifications Issue 6, Copyright (C) 2001-2003 by the Institute of Electrical and Electronics Engineers, Inc and The Open Group. In the event of any discrepancy between this version and the original IEEE and The Open Group Standard, the original IEEE and The Open Group Standard is the referee document. The original Standard can be obtained online at http://www.opengroup.org/unix/online.html .

Modified by Ross Johnson for use with Pthreads-w32.

Table of Contents

- Name

- Synopsis

- Description

- Return Value

- Errors

- Examples

- Application Usage

- Rationale

- Future Directions

- See Also

- Copyright